package com.huimv.env.lamp.service.impl;

import com.huimv.env.common.service.ILampConfigService;
import com.huimv.env.common.service.ILampTempService;
import com.huimv.env.common.utils.DateUtil;
import com.huimv.env.common.utils.MathUtil;
import com.huimv.env.lamp.service.LampInputHandleService;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.ParseException;

/**
 * @Project : huimv-env-platform
 * @Package : ${}
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2022/10/15
 **/
@Service
@Slf4j
public class LampInputHandleServiceImpl implements LampInputHandleService {
    @Resource
    private DateUtil dateUtil;
    @Resource
    private ILampTempService lampTempService;
    @Autowired
    private ILampConfigService lampConfigService;

    @Override
    public void synchronizationTime(String askText, String idCode, ChannelHandlerContext ctx) throws ParseException {
        System.out.println("同步时间");
        String answerText = "hm+"+idCode+"+1+" + dateUtil.getNowText() + "+4+end";
        log.info(">>时间同步请求-应答数据>>" + answerText);
        answerCmd(answerText, ctx);
    }

    @Override
    public void getLampTemp(String askText, String idCode, ChannelHandlerContext ctx) throws ParseException {
        System.out.println("上传温度");
        String[] dataArray = askText.split("\\+");
        String tempText = dataArray[4];
        Double temp = MathUtil.ln(Integer.parseInt(tempText));
        String eartemp = new BigDecimal(temp).setScale(1, BigDecimal.ROUND_HALF_UP).toString();
        DateUtil dateUtil = new DateUtil();
        lampTempService.saveLampTemp(idCode,eartemp,dateUtil.getTodayDatetime());
        String answerText = "hm+"+idCode+"+2+0+7+end";
        log.info(">>上传温度请求-应答数据>>" + answerText);
        answerCmd(answerText, ctx);
    }

    @Override
    public void getLampConfig(String askText, String idCode, ChannelHandlerContext ctx) {
        System.out.println("获取温度配置");
        String configTemp = lampConfigService.getLampConfigByDeviceId(idCode);
        String answerText = "hm+"+idCode+"+3+1+"+configTemp+"+7+end";
        log.info(">>获取保温箱温度配置请求-应答数据>>" + answerText);
        answerCmd(answerText, ctx);
    }

    //应答
    public void answerCmd(String answerText, ChannelHandlerContext ctx) {
        ctx.writeAndFlush(Unpooled.copiedBuffer(answerText.getBytes()));
    }
}
